﻿@model IEnumerable<ExploreApilkasiCuti.Models.MasterMenu>

@{
    ViewBag.Title = "Master Menu";
    string collumVisible = "";
    collumVisible = "{'targets': [8], 'visible': true}";
    Layout = "~/Views/Shared/_Layout.cshtml";
}


@section HeadLibrary{
    <link rel="stylesheet" href="~/AdminLTE/plugins/fontawesome-free/css/all.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- DataTables -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
    <!-- Toast-->
    <link rel="stylesheet" href="~/AdminLTE/plugins/sweetalert2-theme-bootstrap-4/bootstrap-4.min.css" />
    <link rel="stylesheet" href="~/AdminLTE/plugins/toastr/toastr.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
    <!-- Google Font: Source Sans Pro -->
    @*    <link href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700" rel="stylesheet">
    *@    <!-- Select2 -->
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="~/AdminLTE/plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="~/AdminLTE/dist/css/adminlte.min.css">
}

<style>
    .content-table {
        border-collapse: collapse;
        margin: 25px 0;
        min-width: 1000px;
        box-shadow: 0 0 20px rgba(0, 0, 0, 0.15);
        width: 100%;
    }

    /* if the browser window is at least 800px-s wide: */
    @@media screen and (min-width: 800px) {
        table {
            width: 90%;
        }
    }

    /* if the browser window is at least 1000px-s wide: */
    @@media screen and (min-width: 1000px) {
        table {
            width: 80%;
        }
    }

    .content-table thead tr {
        background-color: #10ad21;
        color: #ffffff;
        text-align: left;
    }

    .content-table tr, td {
        border: solid black 0.5px;
    }

    .content-table th, td {
        padding: 12px 10px;
        border: solid black 0.5px;
    }

    #dataMasterMenu_filter .iconSearch {
        float: left;
        display: inline-block;
    }

    .help-block {
        color: red;
    }

    @*.has-error {
        color: red;
    }*@
</style>

<div class="card">
    <div class="card-header">
        <h3 class="card-title"> Master Data Menu</h3>
    </div>
    <div class="card-body">
        <!--<div class="dataTables_wrapper dt-bootstrap4">-->
        <div>
            <div class="row">
                <button type="button" class="btn btn-success" onclick="show_modal_insertupdate('ADD')">
                    <i class="fa fa-plus-circle fa"></i>  Tambah Data
                </button>
                <div class="mt-3 col-md-12"></div>
            </div>
            <div class="row">
                <div class="col-sm-12">
                    <!--<table id="dataMasterMenu" class="table table-bordered table-striped dataTable dtr-inline" role="grid" aria-describedby="dataMasterMenu_info">-->
                    <table id="dataMasterMenu" class="table table-bordered table-striped" style="color:black">
                        <thead>
                            <tr>
                                <th>
                                    ID Menu
                                </th>
                                <th>
                                    ID Parent
                                </th>
                                <th>
                                    Nama Menu
                                </th>
                                <th>
                                    Link
                                </th>
                                @*<th>
                                        Icon
                                    </th>
                                    <th>
                                        Is Parent
                                    </th>
                                    <th>
                                        Menu Order
                                    </th>
                                    <th>
                                        Menu Level
                                    </th>
                                    <th>
                                        Created By
                                    </th>
                                    <th>
                                        Created Date
                                    </th>
                                    <th>
                                        Changed By
                                    </th>
                                    <th>
                                        Changed Date
                                    </th>*@
                                <th style:"65px">
                                    Action
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="deleteMenu" tabindex="-1" data-backdrop="static" role="dialog" aria-labelledby="deleteMenuLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" style="text-align:center" id="deleteMenuLabel">Konfirmasi</h5>
                <button class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="false">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <h6 id="deleteMenuBody"></h6>
                <h6 hidden id="idDeleteMenu"></h6>
            </div>
            <div class="modal-footer justify-content-between">
                <button class="btn btn-primary" style="width:45%" onclick="delete_menu()">Yes</button>
                <button class="btn btn-secondary" style="width:45%" data-dismiss="modal">No</button>
            </div>
        </div>
    </div>
</div>

<div class="modal fadr" id="modal_form_insertupdate" role="dialog" data-keyboard="true" data-backdrop="static">
    <div class="modal-dialog modal-lg">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="insertUpdateModal">Tambah Data Menu</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            </div>
            <div class="card card-primary">
                <form role="form" id="form-insertupdate">
                    <div class="card-body">
                        <div class="form-group">
                            <label class="control-label col-md-4">ID Menu</label>
                            <input name="IDMenu" placeholder="ID Menu" id="IDMenu" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>
                        @*<div class="form-group">
                            <label class="control-label col-md-4">ID Parent</label>
                            <select name="IDParent" id="IDParent" class="form-control select2 IDParent" style="width: 100%;">
                            </select>
                            <span class="help-block"></span>
                        </div>*@
                        <div class="form-group">
                            <label class="err-IDParent control-label">ID Parent</label>
                            <select name="IDParent" id="IDParent" class="form-control select2 IDParent" style="width: 100%;">
                            </select>
                            <span id="spanIDParent" class="err-IDParent help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-md-4">Nama Menu</label>
                            <input name="NamaMenu" placeholder="Nama Menu" id="NamaMenu" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-md-4">Link</label>
                            <input name="Link" placeholder="Link" id="Link" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-md-4">Icon</label>
                            <input name="Icon" placeholder="Icon" id="Icon" class="form-control" type="text">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-check">
                            <input type="checkbox" class="form-check-input" id="IsParent">
                            <label class="form-check-label" for="IsParent"><b>Parent Menu</b></label>
                            <input name="IsParentValue" placeholder="IsParentValue" id="IsParentValue" class="form-control" style="display:none" type="text">
                        </div><br>
                        <div class="form-group">
                            <label class="control-label col-md-4">Menu Order</label>
                            <input name="MenuOrder" placeholder="MenuOrder" id="MenuOrder" class="form-control" type="number" min="0" step="1">
                            <span class="help-block"></span>
                        </div>
                        <div class="form-group">
                            <label class="control-label col-md-4">Menu Level</label>
                            <input name="MenuLevel" placeholder="MenuLevel" id="MenuLevel" class="form-control" type="number" min="0" step="1">
                            <span class="help-block"></span>
                        </div>
                        <label class="col-md-12" style="color:red">*Klik Tab untuk pindah field.</label>
                    </div>
                    <div class="card-footer d-flex">
                        <button type="button" id="btnSaveAddUpdate" onclick="add_menu()" class="btn btn-primary mx-auto" style="width:35%">Simpan Data</button>
                        <button type="button" class="btn btn-danger mx-auto" data-dismiss="modal" style="width:35%">Batalkan</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

<div aria-live="polite" aria-atomic="true" style="position: relative; min-height: 200px;">

    <!-- Then put toasts within -->
    <div id="toastResult" class="toast" style="position: absolute; top: 0; right: 0;">
        <div class="toast-header">
            <i class="fa fa-check"></i>
            <strong class="mr-auto">Success</strong>
            <button type="button" class="ml-2 mb-1 close" data-dismiss="toast" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
        <div class="toast-body">
            <h6 class="toast-body-header">Master Menu berhasil update.</h6>
        </div>
    </div>
</div>

@section BodyLibrary{
    <!-- DataTables -->
    <script src="@Url.Content("~/AdminLTE/plugins/datatables/jquery.dataTables.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-bs4/js/dataTables.bootstrap4.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/dataTables.responsive.min.js")"></script>
    <script src="@Url.Content("~/AdminLTE/plugins/datatables-responsive/js/responsive.bootstrap4.min.js")"></script>
    <!-- SweetAlert2 -->
    <script src="@Url.Content("~/AdminLTE/plugins/sweetalert2/sweetalert2.min.js")"></script>
    <!-- Toastr -->
    <script src="@Url.Content("~/AdminLTE/plugins/toastr/toastr.min.js")"></script>
    <!-- DataRender -->
    <script src="@Url.Content("~/AdminLTE/plugins/dataRender/dateTime.js")"></script>
    <!-- Select2 -->
    <script src="~/AdminLTE/plugins/select2/js/select2.full.min.js"></script>

}

@section AdditionalScript{
    <script type="text/javascript">
        var rowId;
        var rowName;
        var masterMenuTable;

        jQuery(document).ready(function ($) {
            masterMenuTable = $("#dataMasterMenu").DataTable({
                @*"processing": true,
                "serverSide": true,
                "filter": true,
                "orderMulti": false,
                "scrollX": true,*@
                "responsive": true,
                "autoWidth": false,
                "ajax": {
                    "datatype": 'json',
                    "url": '@Url.Action("LoadDataMasterMenu")',
                    "type": 'POST',
                    "data": function (data) {

                    }
                },
                "columns": [
                    { "data": "id_menu", "name": "id_menu"},
                    { "data": "id_parent", "name": "id_parent"},
                    { "data": "nama_menu", "name": "nama_menu"},
                    { "data": "link", "name": "link"},
                    //{ "data": "icon", "name": "icon"},
                    //{ "data": "IsParent", "name": "IsParent"},
                    //{ "data": "MenuOrder", "name": "MenuOrder"},
                    //{ "data": "MenuLevel", "name": "MenuLevel"},
                    //{ "data": "created_by", "name": "created_by"},
                    //{ "data": "created_date", "name": "created_date"},
                    //{ "data": "changed_by", "name": "changed_by"},
                    //{ "data": "changed_date", "name": "changed_date"},
                    { "data": "action"},
                ]
            });
            loadDataSelect2();

            $('#btn-filter').click(function () { //button filter event click
                masterMenuTable.ajax.reload(null, false);  //just reload table
            });
            $('#btn-reset').click(function () { //button filter event click
                $(".FilterProvince").empty();
                reload_table();
            });

            $("#check-all").click(function () {
                $(".data-check").prop('checked', $(this).prop('checked'));
            });
            
            

        });
        $('.select2').select2();
        $('.IDParent').parents('.bootbox').removeAttr('tabindex');

        function get_id_delete(id) {
            $("#deleteMenu").modal('show');
            rowName = $(event.target).closest('tr').find('td:nth-child(3)').text().replace(/\s+/g, ' ').trim();
            rowId = id;//$(event.target).closest('tr').find('td:nth-child(1)').text().replace(/\s+/g, '').trim();
            var strConfirm = 'Hapus data menu dengan nama ' + rowName + '?';
            $("#deleteMenuBody").text(strConfirm);
        }

        function show_modal_insertupdate(action) {
            save_method = action;
            if (action == 'ADD') {
                $("#IDMenu").attr('readonly', false);
                //$("#IDParent").attr('readonly', false);
                document.getElementById("form-insertupdate").reset();
                $('.form-group').removeClass('has-error');
                $('.help.block').empty();
                $("#insertUpdateModal").text("Tambah Data Menu");
                unselect_select2();
            } else {
                $("#insertUpdateModal").text("Ubah Data Menu");
            }
            $("#modal_form_insertupdate").modal('show');
        }

        function reload_table() {
            masterMenuTable.ajax.reload(null, false);
        }

        function delete_menu(rowId) {
            if (rowId != null) {
            @*    $.ajax({
                    contentType: 'application/JSON; charset=utf-8',
                    url: '@Url.Content("~/MasterMenu/Delete")',
                    type: 'POST',
                    data: JSON.stringify({ "id": rowId }),
                    beforeSend: function () {
                        Swal.fire({
                            title: 'Processing...',
                            html: "Delete Data.",
                            allowOutsideClick: false,
                            onBeforeOpen: () => {
                                Swal.showLoading()
                            }
                        });
                    },
                    success: function (data) {
                        Swal.close();
                        if (data.response.Code == "200") {
                            $("#deleteMenu").modal('hide');
                            reload_table();
                            toastr.success('Data menu dengan nama ' + rowName + ' berhasil dihapus');
                        } else {
                            $("#deleteMenu").modal('hide');
                            toastr.warning('Data menu dengan nama ' + rowName + ' gagal dihapus');
                        }
                    },
                    error: function (eventError, textStatus, errorThrown) {
                        toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                    }
                });*@

                Swal.fire({
                    title: 'Konfirmasi',
                    text: "Apakah Anda yakin menghapus data dengan ID Menu " + rowId + "?",
                    type: 'warning',
                    showCancelButton: true,
                    confirmButtonColor: '#3085d6',
                    cancelButtonColor: '#d33',
                    confirmButtonText: 'Hapus Data',
                    confirmButtonClass: 'btn btn-primary',
                    cancelButtonClass: 'btn btn-danger ml-1',
                    showLoaderOnConfirm: true,
                    buttonsStyling: false,
                    preConfirm: (delete_part) => {
                        return fetch('@Url.Content("~/MasterMenu/Delete")' + "/" + rowId, {
                            method: 'POST'
                        }).then(response => {
                            if (!response.ok) {
                                return toastr.error(response.statusText, 'Failed!', { "timeOut": 5000 });
                            }
                            return response.json();
                        }).then(result => {
                            if (result.response.Code === '200') {
                                reload_table();
                                return toastr.success('Data dengan ID Menu <strong>' + rowId + '</strong> berhasil dihapus', 'Success!', { "timeOut": 5000 });
                            } else {
                                return toastr.warning('Gagal menghapus data dengan ID Menu <strong>' + rowId + '</strong>', 'Sorry!', { "timeOut": 5000 });
                            }
                        }).catch(error => {
                            Swal.showValidationMessage(
                                `Request failed: ${error}`
                            )
                        })
                    },
                    allowOutsideClick: () => !Swal.isLoading()
                });
            }
        }

        function edit_menu(rowId) {
            document.getElementById("form-insertupdate").reset();
            $('.form-group').removeClass('has-error');
            $(".help-block").empty();
            unselect_select2();
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Action("GetDataByIdMenu")',
                type: 'POST',
                data: JSON.stringify({ "id": rowId }),
                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Get Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    Swal.close();
                    $('[name="IDMenu"]').val(data["data"][0].id_menu);
                    $("#IDMenu").attr("readonly", true);
                    //$('[name="IDParent"]').val(data["data"][0].id_parent);
                    //$("#IDParent").attr("readonly", true);
                    $("#NamaMenu").val(data["data"][0].nama_menu);
                    $("#Link").val(data["data"][0].link);
                    $("#Icon").val(data["data"][0].icon);
                    if (data["data"][0].IsParent == true) {

                        $("#IsParent").attr('checked', true);
                    } else {
                        $("#IsParent").attr('checked', false);
                    }
                    $("#MenuOrder").val(data["data"][0].MenuOrder);
                    $("#MenuLevel").val(data["data"][0].MenuLevel);
                    get_by_id_menu(data["data"][0].id_parent);
                    //show_modal_insertupdate('UPDATE');

                },
                error: function (eventError, textStatus, errorThrown) {
                    toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                }
            });
        }



        function add_menu() {
            var checkBox = document.getElementById("IsParent");
            var numberFormat = "^[0-9]*$";
            var linkFormat = /^[/]+[a-zA-Z0-9-]*$/;
            var doublelinkFormat = /^[/]+[a-zA-Z0-9-]+[/]+[a-zA-Z0-9-]*$/
            $(".err-IDParent").css('color: black');
            $(".form-group").removeClass('has-error');
            $(".help-block").empty();
            var validate = true;
            if ($("#IDMenu").val() == "" || !$("#IDMenu").val().replace(/\s/g, '').length) {
                //$('#IDMenu').parent().parent().parent().addClass('has-error');
                $('#IDMenu').next().text('ID Menu harus diisi');
                validate = false;
            }
            if ($("#IDParent").val() == ""){
                //$('#IDParent').parent().parent().parent().addClass('has-error');
                //$('#IDParent').next().text('ID Parent harus diisi');
                $('#spanIDParent').text('ID Parent harus diisi');
                $('.err-IDParent').css('color: red');
                validate = false;
            }
            if ($("#NamaMenu").val() == "" || !$("#NamaMenu").val().replace(/\s/g, '').length) {
               // $('#NamaMenu').parent().parent().parent().addClass('has-error');
                $('#NamaMenu').next().text('Nama Menu harus diisi');
                validate = false;
            }
            if ($("#Link").val() == "" || !$("#Link").val().replace(/\s/g, '').length) {
                $('#Link').parent().parent().parent().addClass('has-error');
                $('#Link').next().text('Link harus diisi');
                validate = false;
            }
            if (!($("#Link").val().match(linkFormat)) && $("#Link").val() != "#" && !($("#Link").val().match(doublelinkFormat))) {
                $('#Link').parent().parent().parent().addClass('has-error');
                $('#Link').next().text('Masukkan link dimulai dari / contoh: /MasterKaryawan atau # jika tidak memiliki link');
                validate = false;
                
            }
            if ($("#Icon").val() == "" || !$("#Icon").val().replace(/\s/g, '').length) {
                $('#Icon').parent().parent().parent().addClass('has-error');
                $('#Icon').next().text('Icon harus diisi');
                validate = false;
            }
            if ($("#MenuLevel").val() == "" || !$("#MenuLevel").val().replace(/\s/g, '').length) {
                $('#MenuLevel').parent().parent().parent().addClass('has-error');
                $('#MenuLevel').next().text('Menu Level harus diisi dengan angka valid');
                validate = false;
            }
            if (!($("#MenuLevel").val().match(numberFormat))) {
                $('#MenuLevel').parent().parent().parent().addClass('has-error');
                $('#MenuLevel').next().text('Masukkan hanya angka');
                validate = false;
            }
            if ($("#MenuOrder").val() == "" || !$("#MenuOrder").val().replace(/\s/g, '').length) {
                $('#MenuOrder').parent().parent().parent().addClass('has-error');
                $('#MenuOrder').next().text('Menu Order harus diisi dengan angka valid');
                validate = false;
            }

            if (!($("#MenuOrder").val().match(numberFormat))) {
                $('#MenuOrder').parent().parent().parent().addClass('has-error');
                $('#MenuOrder').next().text('Masukkan hanya angka');
                validate = false;
            }
            if (!validate) return;

            if (save_method == 'ADD') {
                url = "@Url.Content("~/MasterMenu/AddMenu")";
                form = "form-insertupdate";
            }
            else if (save_method == 'UPDATE') {
                url = "@Url.Content("~/MasterMenu/UpdateMenu")";
                form = "form-insertupdate";
            }
            if ($('#IsParent').is(':checked')) {
                $('#IsParentValue').val(true);
            } else {
                $('#IsParentValue').val(false);
            }
            $.ajax({
                url: url,
                enctype: 'multipart/form-data',
                type: "POST",
                data: $('#' + form).serialize(),
                dataType: "JSON",

                beforeSend: function () {
                    Swal.fire({
                        title: 'Processing...',
                        html: "Saving Data.",
                        allowOutsideClick: false,
                        onBeforeOpen: () => {
                            Swal.showLoading()
                        }
                    });
                },
                success: function (data) {
                    Swal.close();
                    if (data.response.Code == "200") {
                        $("#modal_form_insertupdate").modal('hide');
                        reload_table();
                        save_method == "ADD" ?
                            toastr.success("Data dengan ID Menu <strong>" + $("#IDMenu").val() + "</strong> berhasil ditambahkan", "Success!", { "timeOut": 5000 }) :
                            toastr.success("Data dengan ID Menu <strong>" + $("#IDMenu").val() + "</strong> berhasil diubah", "Success!", { "timeOut" : 5000});
                    } else {
                        save_method == "ADD" ?
                            toastr.warning("Gagal menambahkan data dengan ID Menu <strong>" + $("#IDMenu").val() + "</strong>", "Sorry! " + data.metaData.message, { "timeOut": 5000 }) :
                            toastr.warning("Gagal mengubah data dengan ID Menu <strong>" + $("#IDMenu").val() + "</strong>", "Sorry!", { "timeOut": 5000 });
                    }
                },
                error: function (eventError, textStatus, errorThrown) {
                    $('#btnSaveAddUpdate').text('Save'); //change button text
                    $('#btnSaveAddUpdate').attr('disabled', false);
                    toastr.error(formatErrorMessage(eventError, errorThrown), 'Failed!', { "timeOut": 5000 });
                }
            });
        }

        @*$(function () {
            $("#dataMasterJabatan").DataTable({
                "responsive": true,
                "autoWidth": false,
            });
        });*@

        function loadDataSelect2() {
            $.ajax({
                url: '@Url.Content("~/MasterMenu/getListParentMenu")',
                type: 'POST',
                dataType: 'json',
                delay: 250,
                processResults: function (data) {
                    return {
                        results: $.map(data['data'], function (item) {
                            return {
                                text: item.id_menu + ' - ' + item.nama_menu,
                                id: item.id_menu
                            }
                        })
                    };
                }
            }).then(
                function (response) {
                    $('#IDParent').select2({
                        dropdownParent: ("#modal_form_insertupdate"),
                        multiple: false,
                        allowClear: true,
                        placeholder: '- Pilih Parent Menu-',
                        width: '100%',
                        //theme: 'bootstrap4',
                        data: $.map(response.data, function (item) {
                            return {
                                text: item.id_menu + ' - ' + item.nama_menu,
                                id: item.id_menu
                            }
                        })
                    });
                }
            );
        }
        function unselect_select2() {
            $('#IDParent').append($("<option/>").val('').text('')).val('');
            $('#IDParent').val('').trigger("change");

        }
        function get_by_id_menu(id_parent) {
            $.ajax({
                contentType: 'application/JSON; charset=utf-8',
                url: '@Url.Content("~/MasterMenu/GetByID")',
                type: 'POST',
                data: JSON.stringify({ "id": id_parent }),
                success: function (data) {

                    if (data.response == "403") {
                        $('#IDParent').val("0").trigger("change");
                    } else {
                        $('#IDParent').val(data.response[0].id_menu).trigger("change");
                    }
                    show_modal_insertupdate('UPDATE');
                },
                error: function () {
                    var s = "<option value='-1'></option>";
                    $("#IDParent").html(s);
                }
            });
        }
    </script>
}
